import java.util.HashMap;

public class TCPReceiverStack implements TransportReceiver {
    Link sender_link;
    HashMap<Integer, TCPReceiver> receivers = new HashMap<Integer, TCPReceiver>();

    public void connect(TCPReceiver s, ApplicationReceiver r) {
	receivers.put(s.src_port, s);
	s.app = r;
    }

    public void connect(Link l) {
	sender_link = l;
    }

    public void deliver(Packet packet) {
	if (packet instanceof TCPPacket) {
	    TCPPacket p = (TCPPacket)packet;
	    TCPReceiver r = receivers.get(p.dst_port);
	    if (r == null) {
		System.out.printf("%f ", Simulation.time());
		System.out.println("TCPReceiverStack: no application on port " + p.dst_port); 
	    } else {
		r.deliver(p);
	    }
	}
    }
}
